git-stash.shon commit git-clone: split up long &&-command-chain and use a function for cleanup (68ad891)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4USAGE='[ | list | show | apply | clear]'
   5
   6. git-sh-setup
   7require_work_tree
   8
   9TMP="$GIT_DIR/.git-stash.$$"
  10trap 'rm -f "$TMP-*"' 0
  11
  12ref_stash=refs/stash
  13
  14no_changes () {
  15        git diff-index --quiet --cached HEAD &&
  16        git diff-files --quiet
  17}
  18
  19clear_stash () {
  20        logfile="$GIT_DIR/logs/$ref_stash" &&
  21        mkdir -p "$(dirname "$logfile")" &&
  22        : >"$logfile"
  23}
  24
  25save_stash () {
  26        stash_msg="$1"
  27
  28        if no_changes
  29        then
  30                echo >&2 'No local changes to save'
  31                exit 0
  32        fi
  33        test -f "$GIT_DIR/logs/$ref_stash" ||
  34                clear_stash || die "Cannot initialize stash"
  35
  36        # state of the base commit
  37        if b_commit=$(git rev-parse --verify HEAD)
  38        then
  39                head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
  40        else
  41                die "You do not have the initial commit yet"
  42        fi
  43
  44        if branch=$(git symbolic-ref -q HEAD)
  45        then
  46                branch=${branch#refs/heads/}
  47        else
  48                branch='(no branch)'
  49        fi
  50        msg=$(printf '%s: %s' "$branch" "$head")
  51
  52        # state of the index
  53        i_tree=$(git write-tree) &&
  54        i_commit=$(printf 'index on %s' "$msg" |
  55                git commit-tree $i_tree -p $b_commit) ||
  56                die "Cannot save the current index state"
  57
  58        # state of the working tree
  59        w_tree=$( (
  60                GIT_INDEX_FILE="$TMP-index" &&
  61                export GIT_INDEX_FILE &&
  62
  63                rm -f "$TMP-index" &&
  64                git read-tree $i_tree &&
  65                git add -u &&
  66                git write-tree &&
  67                rm -f "$TMP-index"
  68        ) ) ||
  69                die "Cannot save the current worktree state"
  70
  71        # create the stash
  72        if test -z "$stash_msg"
  73        then
  74                stash_msg=$(printf 'WIP on %s' "$msg")
  75        else
  76                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
  77        fi
  78        w_commit=$(printf '%s\n' "$stash_msg" |
  79                git commit-tree $w_tree -p $b_commit -p $i_commit) ||
  80                die "Cannot record working tree state"
  81
  82        git update-ref -m "$stash_msg" $ref_stash $w_commit ||
  83                die "Cannot save the current status"
  84        printf >&2 'Saved "%s"\n' "$stash_msg"
  85}
  86
  87have_stash () {
  88        git rev-parse --verify $ref_stash >/dev/null 2>&1
  89}
  90
  91list_stash () {
  92        have_stash || return 0
  93        git log --pretty=oneline -g "$@" $ref_stash |
  94        sed -n -e 's/^[.0-9a-f]* refs\///p'
  95}
  96
  97show_stash () {
  98        flags=$(git rev-parse --no-revs --flags "$@")
  99        if test -z "$flags"
 100        then
 101                flags=--stat
 102        fi
 103        s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
 104
 105        w_commit=$(git rev-parse --verify "$s") &&
 106        b_commit=$(git rev-parse --verify "$s^") &&
 107        git diff $flags $b_commit $w_commit
 108}
 109
 110apply_stash () {
 111        git diff-files --quiet ||
 112                die 'Cannot restore on top of a dirty state'
 113
 114        # current index state
 115        c_tree=$(git write-tree) ||
 116                die 'Cannot apply a stash in the middle of a merge'
 117
 118        s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
 119        w_tree=$(git rev-parse --verify "$s:") &&
 120        b_tree=$(git rev-parse --verify "$s^:") ||
 121                die "$*: no valid stashed state found"
 122
 123        eval "
 124                GITHEAD_$w_tree='Stashed changes' &&
 125                GITHEAD_$c_tree='Updated upstream' &&
 126                GITHEAD_$b_tree='Version stash was based on' &&
 127                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 128        "
 129
 130        if git-merge-recursive $b_tree -- $c_tree $w_tree
 131        then
 132                # No conflict
 133                a="$TMP-added" &&
 134                git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
 135                git read-tree --reset $c_tree &&
 136                git update-index --add --stdin <"$a" ||
 137                        die "Cannot unstage modified files"
 138                git-status
 139                rm -f "$a"
 140        else
 141                # Merge conflict; keep the exit status from merge-recursive
 142                exit
 143        fi
 144}
 145
 146# Main command set
 147case "$1" in
 148list)
 149        shift
 150        if test $# = 0
 151        then
 152                set x -n 10
 153                shift
 154        fi
 155        list_stash "$@"
 156        ;;
 157show)
 158        shift
 159        show_stash "$@"
 160        ;;
 161apply)
 162        shift
 163        apply_stash "$@"
 164        ;;
 165clear)
 166        clear_stash
 167        ;;
 168help | usage)
 169        usage
 170        ;;
 171*)
 172        if test $# -gt 0 && test "$1" = save
 173        then
 174                shift
 175        fi
 176        save_stash "$*" && git-reset --hard
 177        ;;
 178esac